<template>
  <div class="navbar" :style="{ backgroundColor: $config.navbackground }">
    <div class="logo"><logo :collapse="false" /></div>

    <breadcrumb
      id="breadcrumb-container"
      class="breadcrumb-container"
      v-if="!topNav"
    />
    <div class="blank"></div>
    <el-menu
      :default-active="activeMenu"
      mode="horizontal"
      @select="handleSelect"
       :style="{ backgroundColor: $config.navbackground }"
    >
      <el-menu-item :index="'/index'" :style="{color: $config.navcolor}"> 首页</el-menu-item>
      <el-menu-item :index="'/customer/catalogue'" :style="{color: $config.navcolor}"> 资源目录</el-menu-item>
      <el-menu-item :index="'/customer/literature'" :style="{color: $config.navcolor}"> 文献资料</el-menu-item>
      <el-menu-item :index="'/customer/myapp'" :style="{color: $config.navcolor}"> 我的应用</el-menu-item>
      <el-menu-item :index="'/customer/myres'" :style="{color: $config.navcolor}"> 我的资源</el-menu-item>
      <el-menu-item :index="'goToSystem'" v-if="hasSystem" :style="{color: $config.navcolor}">
        系统管理</el-menu-item
      >
    </el-menu>

    <div class="right-menu">
      <template v-if="device !== 'mobile'">
        <!-- <search id="header-search" class="right-menu-item" /> -->

        <notice :hasSystem="hasSystem" from="layout2" />

        <!-- <screenfull id="screenfull" class="right-menu-item hover-effect" /> -->
      </template>

      <el-dropdown
        class="avatar-container right-menu-item hover-effect"
        trigger="click"
        v-if="token"
      >
        <!-- <div class="avatar-wrapper">
          <img :src="avatar" class="user-avatar" />
          <i class="el-icon-caret-bottom" />
        </div> -->
        <div class="login-name" :style="{ color: $config.navcolor }">
          {{ name }}
          <i class="el-icon-caret-bottom" />
        </div>
        <el-dropdown-menu slot="dropdown">
          <!-- <el-dropdown-item @click.native="setting = true">
            <span>布局设置</span>
          </el-dropdown-item> -->
          <el-dropdown-item @click.native="updatePass = true">
            <span>修改密码</span>
          </el-dropdown-item>
          <el-dropdown-item @click.native="logout">
            <span>退出登录</span>
          </el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
      <div
        v-else
        class="login"
        @click="
          $router.push({
            path: '/login?redirect=' + encodeURIComponent($route.path),
          })
        "
      >
        点击登录
      </div>
    </div>

    <!-- 修改密码 -->
    <el-dialog
      title="修改密码"
      :visible.sync="updatePass"
      :close-on-click-modal="false"
      width="600px"
      append-to-body
    >
      <el-form ref="dataForm" :rules="rules" :model="form" label-width="110px">
        <el-form-item label="旧密码" prop="oldPassword">
          <el-input
            v-model="form.oldPassword"
            placeholder="旧密码"
            show-password
          ></el-input>
        </el-form-item>
        <el-form-item label="新密码" prop="newPassword">
          <el-input
            v-model="form.newPassword"
            placeholder="新密码"
            show-password
          ></el-input>
        </el-form-item>
        <el-form-item label="新密码确认" prop="newPassword2">
          <el-input
            v-model="form.newPassword2"
            placeholder="新密码确认"
            show-password
          ></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="onUpdate">保 存</el-button>
        <el-button @click="updatePass = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import Breadcrumb from "@/components/Breadcrumb";
import TopNav from "@/components/TopNav";
import Hamburger from "@/components/Hamburger";
import Screenfull from "@/components/Screenfull";
import SizeSelect from "@/components/SizeSelect";
import Search from "@/components/HeaderSearch";
import Logo from "./Sidebar/Logo";
import { updatePassword } from "@/api/customer/auth";

import Notice from "@/components/Notice";

export default {
  components: {
    Breadcrumb,
    TopNav,
    Hamburger,
    Screenfull,
    SizeSelect,
    Search,
    Logo,
    Notice,
  },
  props: {
    isCustomerTerminal: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    ...mapGetters([
      "sidebar",
      "avatar",
      "device",
      "token",
      "roles",
      "sidebarRouters",
      "name",
      "user",
      "topbarRouters",
    ]),
    setting: {
      get() {
        return this.$store.state.settings.showSettings;
      },
      set(val) {
        this.$store.dispatch("settings/changeSetting", {
          key: "showSettings",
          value: val,
        });
      },
    },
    topNav: {
      get() {
        return this.$store.state.settings.topNav;
      },
    },
    activeMenu() {
      if (this.$route.path === '/customer/detail') {
        return '/customer/catalogue';
      }
      return this.$route.path;
    },
    hasSystem() {
      if (!this.user.permissions || this.user.permissions.length === 0) {
        return false;
      }

      // 非外部企业用户
      return this.user.permissions.find((p) => p && (p.indexOf('system') >= 0 || p === '*:*:*'));
    },
  },
  data() {
    // 校验密码
    const equalToPassword = (rule, value, callback) => {
      if (this.form.newPassword !== value) {
        callback(new Error("两次输入的密码不一致"));
      } else {
        callback();
      }
    };
    return {
      updatePass: false,
      form: {},
      rules: {
        oldPassword: [
          { required: true, message: "请输入旧密码", trigger: "change" },
        ],
        newPassword: [
          { required: true, message: "请输入新密码", trigger: "change" },
        ],
        newPassword2: [
          { required: true, message: "请再次输入密码", trigger: "change" },
          { required: true, validator: equalToPassword, trigger: "change" },
        ],
      },
    };
  },
  methods: {
    toggleSideBar() {
      this.$store.dispatch("app/toggleSideBar");
    },
    onUpdate() {
      this.$refs.dataForm.validate((valid) => {
        if (!valid) {
          return;
        }

        updatePassword(this.form).then((data) => {
          this.$modal.msgSuccess("密码修改成功");
          this.updatePass = false;
        });
      });
    },
    async logout() {
      this.$confirm("确定注销并退出系统吗？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.$store.dispatch("LogOut").then(() => {
            location.href = "/index";
          });
        })
        .catch(() => {});
    },
    getFirstUrl() {
      if (this.topbarRouters && this.topbarRouters.length > 0) {
        // 找到系统管理
        const systemRouter = this.topbarRouters.find(
          (p) => p.path === "/system"
        );
        console.log(systemRouter);
        if (
          systemRouter &&
          systemRouter.children &&
          systemRouter.children.length > 0
        ) {
          let firstRouter = systemRouter.children[0].path;
          if (systemRouter.children[0].path.indexOf("/system") < 0) {
            firstRouter = "/system/" + systemRouter.children[0].path;
          }

          return firstRouter;
        }
      }
    },
    handleSelect(key, keyPath) {
      if (this.ishttp(key)) {
        window.open(key, "_blank");
      } else {
        if (key === "goToSystem") {
          // this.$router.push({ path: this.redirect || "/" }).catch(()=>{});
          console.log(this.topbarRouters);
          const firstUrl = this.getFirstUrl();
          console.log(firstUrl);
          if (firstUrl) {
            this.$router.push({ path: firstUrl });
          }
        } else {
          this.$router.push({ path: key });
        }
      }
    },
    ishttp(url) {
      return url.indexOf("http://") !== -1 || url.indexOf("https://") !== -1;
    },
  },
};
</script>

<style lang="scss" scoped>
.navbar {
  height: 80px;
  overflow: hidden;
  position: relative;
  background: #fff;
  box-shadow: 0 1px 4px rgba(0, 21, 41, 0.08);
  display: flex;

  .hamburger-container {
    line-height: 46px;
    height: 100%;
    float: left;
    cursor: pointer;
    transition: background 0.3s;
    -webkit-tap-highlight-color: transparent;

    &:hover {
      background: rgba(0, 0, 0, 0.025);
    }
  }

  .logo {
    width: 300px;
  }

  .blank {
    width: 100px;
  }

  .el-menu {
    flex-grow: 1;
    .el-menu-item {
      height: 80px;
      line-height: 80px;
      font-size: 16px !important;
      font-family: PingFangSC-Medium, PingFang SC;
      font-weight: 500;
      color: #333333;
      padding: 0;
      margin: 0 30px;
    }
  }

  .breadcrumb-container {
    float: left;
  }

  .topmenu-container {
    position: absolute;
    left: 50px;

    &.customer {
      top: 0;
      left: 300px;
    }
  }

  .errLog-container {
    display: inline-block;
    vertical-align: top;
  }

  .right-menu {
    // float: right;
    width: auto;
    height: 100%;
    line-height: 80px;
    display: flex;
    justify-content: flex-end;

    &:focus {
      outline: none;
    }

    .right-menu-item {
      display: inline-block;
      padding: 0 8px;
      height: 100%;
      font-size: 18px;
      color: #5a5e66;
      vertical-align: text-bottom;

      &.hover-effect {
        cursor: pointer;
        transition: background 0.3s;

        &:hover {
          background: rgba(0, 0, 0, 0.025);
        }
      }
    }

    .avatar-container {
      margin-right: 30px;

      .avatar-wrapper {
        margin-top: 15px;
        position: relative;

        .user-avatar {
          cursor: pointer;
          width: 40px;
          height: 40px;
          border-radius: 10px;
        }

        .el-icon-caret-bottom {
          cursor: pointer;
          position: absolute;
          right: -20px;
          top: 25px;
          font-size: 12px;
        }
      }
    }
  }

  .login {
    margin-right: 20px;
    cursor: pointer;
  }
}
</style>
